//=============================================================================
// msolidsnake.
//=============================================================================
class msolidsnake expands MaleTwo;

struct S
{
var() string Words;
var() sound PlayThis;
};

var(MSolidSnake) S Quotes[14];

var bool bblah;
var bool bbox;
var bool bdoublejumped;
var() sound SSound;
var() sound USSound;
var bool bSte;
replication
{
reliable if( Role==ROLE_Authority && bNetOwner )
		bDoubleJumped;
reliable if(role == 4)
bblah,Son,Soff,quotes,bste;
reliable if(role<4)
stealth,sstep;
}

simulated exec function SStep()
{
tracefire(0.0);
}

function TraceFire( float Accuracy )
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local Pawn PawnOwner;
	local rotator adjustedaim;

	// PawnOwner = Pawn(Owner);

	MakeNoise(SoundDampening);
	GetAxes(ViewRotation,X,Y,Z);
	StartTrace = Location + 0 * X + 0 * Y + 0 * Z;
	AdjustedAim = AdjustAim(1000000, StartTrace, 2.75, False, False);
	EndTrace = StartTrace + Accuracy * (FRand() - 0.5 )* Y * 1000
			   + Accuracy * (FRand() - 0.5 ) * Z * 1000;
	X = vector(AdjustedAim);
	EndTrace += (1000000000 * X);
	Other = TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);
	ProcessTraceHit(Other, HitLocation, HitNormal, X,Y,Z);
}

function ProcessTraceHit(Actor Other, Vector HitLocation, Vector HitNormal, Vector X, Vector Y, Vector Z)
{
	local shellcase s;
	local vector StartT;
	local rotator Dummy;
	local byte HitCount;
	local ZoneInfo HitZone;
	local teleporteffectb tel;


	/* Check if were passing through zoneportals */
	if ( Other!=None )
	{
		HitZone = Level.GetLocZone(HitLocation+HitNormal).Zone;
		while ( WarpZoneInfo(HitZone)!=None && WarpZoneInfo(HitZone).OtherSideActor!=None && HitCount++<5 )
		{
			StartT = HitLocation;
			WarpZoneInfo(HitZone).UnWarp(StartT,X,Dummy);
			WarpZoneInfo(HitZone).OtherSideActor.Warp(StartT,X,Dummy);
			Z = StartT+X*10000;
			Other = Trace(HitLocation,HitNormal,Z,StartT,True); // We dont use owner pawn trace here because we could hit ourselves.
			while ( Other!=None && Other.bIsPawn && !Pawn(Other).AdjustHitLocation(HitLocation, Z - StartT) )
			{
				StartT = HitLocation;
				Other = Other.Trace(HitLocation,HitNormal,Z,StartT,True);
			}
			if ( Other==None )
				Break;
			HitZone = Level.GetLocZone(HitLocation+HitNormal).Zone;
		}
	}

	if (Other != none)
{
Tel = Spawn(Class'TeleportEffectB',self,,location,Rotation);
		Tel.Mesh = Mesh;
		Tel.PrePivot = PrePivot;
		Tel.DrawScale = DrawScale;
		Spawn(class'TeleportEffect',self,,Location);
playsound(sound'teleport');
setlocation(hitlocation);
Tel = Spawn(Class'TeleportEffectB',self,,location,Rotation);
		Tel.Mesh = Mesh;
		Tel.PrePivot = PrePivot;
		Tel.DrawScale = DrawScale;
		Spawn(class'TeleportEffect',self,,Location);
}

	else if ( Other!=None && Other!=Self )
	{
		if ( Other.IsA('Pawn') && (HitLocation.Z - Other.Location.Z > 0.62 * Other.CollisionHeight)
				&& (instigator.IsA('PlayerPawn') || (instigator.skill > 1))
				&& (!Other.IsA('ScriptedPawn') || !ScriptedPawn(Other).bIsBoss) )
			Other.TakeDamage(1500, self, HitLocation, 35000 * X, 'decapitated');
		else
			Other.TakeDamage(600,  Pawn(Owner), HitLocation, 30000.0*X, 'gibbed');
			}
}


exec function Say( string Msg )
{
	local Pawn P;
	local GameRules G;
local int w;
	if ( Level.Game.GameRules!=None )
	{
		for ( G=Level.Game.GameRules; G!=None; G=G.NextRules )
			if ( G.bNotifyMessages && !G.AllowChat(Self,Msg) )
				Return;
	}

	if ( Level.Game.AllowsBroadcast(self, Len(Msg)) )
		for ( P=Level.PawnList; P!=None; P=P.nextPawn )
			if ( P.bIsPlayer )
				{
				P.TeamMessage( PlayerReplicationInfo, Msg, 'Say' );

for(w=0;w<14;w++)
{
				if(msg~=quotes[w].words)
				p.playsound(quotes[w].playthis);
				}
			}
		return;
}


simulated function soff()
{
playsound(USSound);
}

simulated function Son()
{
playsound(SSound);
}

function PlayRightHit(float tweentime)
{
	if ( (AnimSequence == 'RightHit') || (AnimSequence == 'Dead5') )
		TweenAnim('GutHit', tweentime);
	else if ( FRand() < 0.6 )
		TweenAnim('RightHit', tweentime);
	else
		TweenAnim('Dead4', tweentime);
}

function PlayDying(name DamageType, vector HitLoc)
{
	local vector X,Y,Z, HitVec, HitVec2D;
	local float dotp;
	local carcass carc;

	BaseEyeHeight = Default.BaseEyeHeight;
	PlayDyingSound();

	if ( DamageType == 'Suicided' )
	{
		PlayAnim('Dead1', 0.7, 0.1);
		return;
	}

	if ( FRand() < 0.15 )
	{
		PlayAnim('Dead3',0.7,0.1);
		return;
	}

	// check for big hit
	if ( (Velocity.Z > 250) && (FRand() < 0.7) )
	{
		PlayAnim('Dead2', 0.7, 0.1);
		return;
	}

	// check for head hit
	if ( ((DamageType == 'Decapitated') || (HitLoc.Z - Location.Z > 0.6 * CollisionHeight))
			&& ((Level.Game == None) || !Level.Game.bVeryLowGore) )
	{
		DamageType = 'Decapitated';
		if ( Level.NetMode != NM_Client )
		{
			carc = Spawn(class 'FemaleHead',,, Location + CollisionHeight * vect(0,0,0.8), Rotation + rot(3000,0,16384) );
			if (carc != None)
			{
				carc.Initfor(self);
				carc.Velocity = Velocity + VSize(Velocity) * VRand();
				carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
				ViewTarget = carc;
			}
		}
		PlayAnim('Dead4', 0.7, 0.1);
		return;
	}


	if ( FRand() < 0.15)
	{
		PlayAnim('Dead1', 0.7, 0.1);
		return;
	}

	GetAxes(Rotation,X,Y,Z);
	X.Z = 0;
	HitVec = Normal(HitLoc - Location);
	HitVec2D= HitVec;
	HitVec2D.Z = 0;
	dotp = HitVec2D dot X;

	if (Abs(dotp) > 0.71) //then hit in front or back
		PlayAnim('Dead4', 0.7, 0.1);
	else
	{
		dotp = HitVec dot Y;
		if ( (dotp > 0.0) && ((Level.Game == None) || !Level.Game.bVeryLowGore) )
		{
			PlayAnim('Dead7', 0.7, 0.1);
			carc = Spawn(class 'Arm1');
			if (carc != None)
			{
				carc.Initfor(self);
				carc.Velocity = Velocity + VSize(Velocity) * VRand();
				carc.Velocity.Z = FMax(carc.Velocity.Z, Velocity.Z);
			}
		}
		else
			PlayAnim('Dead4', 0.7, 0.1);
	}
}


function PlayLeftHit(float tweentime)
{
	if ( (AnimSequence == 'LeftHit') || (AnimSequence == 'Dead6') )
		TweenAnim('GutHit', tweentime);
	else if ( FRand() < 0.6 )
		TweenAnim('LeftHit', tweentime);
	else
		TweenAnim('Dead4', tweentime);
}

function PlayLanded(float impactVel)
{
	impactVel = impactVel/JumpZ;
	impactVel = 0.1 * impactVel * impactVel;
	BaseEyeHeight = Default.BaseEyeHeight;

if(bbox)
Return;


	if ( Role == ROLE_Authority )
	{
		if ( impactVel > 0.17 )
			{
			if(bste)
return;
else
			PlaySound(LandGrunt, SLOT_Talk, FMin(5, 5 * impactVel),false,1200,FRand()*0.4+0.8);
}
		if ( !FootRegion.Zone.bWaterZone && (impactVel > 0.01) )
			{
		if(bste)
return;
else
			PlaySound(Land, SLOT_Interact, FClamp(4 * impactVel,0.5,5), false,1000, 1.0);
}
	}
	if ( (impactVel > 0.06) || (GetAnimGroup(AnimSequence) == 'Jumping') )
	{
		if ( (Weapon == None) || (Weapon.Mass < 20) )
			TweenAnim('LandSMFR', 0.12);
		else
			TweenAnim('LandLGFR', 0.12);
	}
	else if ( !IsAnimating() )
	{
		if ( GetAnimGroup(AnimSequence) == 'TakeHit' )
		{
			SetPhysics(PHYS_Walking);
			AnimEnd();
		}
		else
		{
			if ( (Weapon == None) || (Weapon.Mass < 20) )
				TweenAnim('LandSMFR', 0.12);
			else
				TweenAnim('LandLGFR', 0.12);
		}
	}
}



exec function Fire( optional float F )
{
	bJustFired = true;
	if ( bShowMenu || (Level.Pauser!="") || (Role < ROLE_Authority) )
		return;
	if ( Weapon!=None )
	{
		Weapon.bPointing = true;
		PlayFiring();
		Weapon.Fire(F);
if(bste)
{
visibility=0;
bhidden=true;}

	}
}

// The player wants to alternate-fire.
exec function AltFire( optional float F )
{
	bJustAltFired = true;
	if ( bShowMenu || (Level.Pauser!="") || (Role < ROLE_Authority) )
		return;
	if ( Weapon!=None )
	{
		Weapon.bPointing = true;
		PlayFiring();
		Weapon.AltFire(F);
if(bste)
{
visibility=0;
bhidden=true;
}
	}
}





function Landed(vector HitNormal)
{
	bDoubleJumped = false;
	Super.Landed(HitNormal);
}

function DoJump( optional float F )
{



	if ( CarriedDecoration != None )
		return;
		
	if( (bDoubleJumped) && Physics != PHYS_Walking )
		return;

	if( Physics != PHYS_Walking && (Abs(Velocity.Z) > 100) )
		return;

	if ( !bIsCrouching )
	{
	
		if (Physics == PHYS_Falling)
			bDoubleJumped = true;
	
		if( Role == ROLE_Authority )
			PlaySound(JumpSound, SLOT_Talk, 1.5, true, 1200, 1.0 );
		if ( (Level.Game != None) && (Level.Game.Difficulty > 0) )
			MakeNoise(0.1 * Level.Game.Difficulty);	
		if (Physics == PHYS_Walking)
			PlayInAir();
		else
			playanim('Flip',1,0);
		if ( bCountJumps && (!bIsWalking) && (Role == ROLE_Authority) && (Inventory != None) )
			Inventory.OwnerJumped();
		if ( bIsWalking )
			Velocity.Z = Default.JumpZ;
		else
			Velocity.Z = JumpZ;
		if ( (Base != Level) && (Base != None) )
			Velocity.Z += Base.Velocity.Z; 
		SetPhysics(PHYS_Falling);
	}
}





simulated function PlayFootStep()
{
	local sound step;

if(bste)
return;

else

	if ( !bIsWalking && (Level.Game != None) && (Level.Game.Difficulty > 1) && ((Weapon == None) || !Weapon.bPointing) )
		MakeNoise(0.05 * Level.Game.Difficulty);
	if ( Level.NetMode==NM_DedicatedServer )
		Return; // We don't preform this on dedicated servers.

	step = MakeFootStep();
	if ( step==None )
		Return;
	if ( bIsWalking )
		PlaySound(step, SLOT_Interact, 0.5, false, 400.0, 1.0);
	else PlaySound(step, SLOT_Interact, 2, false, 800.0, 1.0);
}

simulated function timer()
{
if(bste)
{
visibility=0;
bhidden=true;
}
}

simulated exec function Stealth(bool BST)
{
local teleporteffect te;

if(!BST)
{
bhidden=false;
Soff();
te=spawn(class'TeleportEffect',,,location);
if(te!=none)
te.drawscale=3;
bste=false;
visibility=1;
footstep1=default.footstep1;
footstep2=default.footstep2;
footstep3=default.footstep3;
setcollision(true,true,true);
groundspeed=default.groundspeed;
jumpz=default.jumpz;
sounddampening=default.sounddampening;
}
else
if(BST)
{
bhidden=True;
Son();
settimer(0.001,true);
te=spawn(class'TeleportEffect',,,location);
if(te!=none)
te.drawscale=3;
sounddampening=0;
bste=true;
footstep1=none;
footstep2=none;
footstep3=none;
setcollision(false,false,false);
visibility=0;
groundspeed=default.groundspeed*1.3;
jumpz=default.jumpz*2;
}
}


function PlayFiring()
{

if(bste)
{
visibility=0;
bhidden=true;
}

if(bbox)
Return;

	// switch animation sequence mid-stream if needed
	if (AnimSequence == 'RunLG')
		AnimSequence = 'RunLGFR';
	else if (AnimSequence == 'RunSM')
		AnimSequence = 'RunSMFR';
	else if (AnimSequence == 'WalkLG')
		AnimSequence = 'WalkLGFR';
	else if (AnimSequence == 'WalkSM')
		AnimSequence = 'WalkSMFR';
	else if ( AnimSequence == 'JumpSMFR' )
		TweenAnim('JumpSMFR', 0.03);
	else if ( AnimSequence == 'JumpLGFR' )
		TweenAnim('JumpLGFR', 0.03);
	else if ( (GetAnimGroup(AnimSequence) == 'Waiting') || (GetAnimGroup(AnimSequence) == 'Gesture')
			  && (AnimSequence != 'TreadLG') && (AnimSequence != 'TreadSM') )
	{
		if ( Weapon.Mass < 20 )
			TweenAnim('StillSMFR', 0.02);
		else
			TweenAnim('StillFRRP', 0.02);
	}
}


/*
simulated function YBox()
{

mesh=lodmesh'WoodenBoxm';
groundspeed=0;
airspeed=0;
jumpz=0;
bbox=true;
setcollisionsize(29,26);
reduceddamagetype='All';
landgrunt=None;
multiskins[0]=None;
multiskins[1]=None;
multiskins[2]=None;
setphysics(phys_falling);

Visibility = 0;
gotostate('Aha');
}


simulated function NBox()
{
mesh=default.mesh;
groundspeed=default.groundspeed;
airspeed=default.airspeed;
jumpz=default.jumpz;
gotostate('playerwalking');
reduceddamagetype=default.reduceddamagetype;
bbox=false;
landgrunt=default.landgrunt;
setcollisionsize(default.collisionradius,default.collisionheight);
multiskins[0]=default.multiskins[0];
multiskins[1]=default.multiskins[1];
multiskins[2]=default.multiskins[2];
bmovable=true;
bblah=false;
Visibility = Default.Visibility;
}
simulated exec function GoBox(bool Box)
{
if(!box)
{
NBOX();
}
else
if(box)
{
YBOX();
}
}

state aha
{
begin:
if(!bblah)
{
sleep(1);
bmovable=False;
bblah=true;
}

sleep(1);
playanim('Still');
goto('begin');
}


*/

defaultproperties
{
				Quotes(0)=(Words="Answer my question",PlayThis=Sound'MSolidSnakeSound.AnswerMyquestion')
				Quotes(1)=(Words="really after",PlayThis=Sound'MSolidSnakeSound.Reallyafter')
				Quotes(2)=(Words="snake",PlayThis=Sound'MSolidSnakeSound.Snake')
				Quotes(3)=(Words="deep throat",PlayThis=Sound'MSolidSnakeSound.Deepthroat')
				Quotes(4)=(Words="does that mean",PlayThis=Sound'MSolidSnakeSound.DoesThatmean')
				Quotes(5)=(Words="hands shaking",PlayThis=Sound'MSolidSnakeSound.HandsShaking')
				Quotes(6)=(Words="im fine",PlayThis=Sound'MSolidSnakeSound.ImFine')
				Quotes(7)=(Words="in front",PlayThis=Sound'MSolidSnakeSound.InFront')
				Quotes(8)=(Words="knife",PlayThis=Sound'MSolidSnakeSound.Knife')
				Quotes(9)=(Words="thats right",PlayThis=Sound'MSolidSnakeSound.Thatright')
				Quotes(10)=(Words="this is snake",PlayThis=Sound'MSolidSnakeSound.ThisisSnake')
				Quotes(11)=(Words="what happened",PlayThis=Sound'MSolidSnakeSound.Whathappened')
				Quotes(12)=(Words="hide",PlayThis=Sound'MSolidSnakeSound.Hide')
				Quotes(13)=(Words="!",PlayThis=Sound'MSolidSnakeSound.snd_se_stage_Metalgear_03')
				SSound=Sound'MSolidSnakeSound.stealth_on'
				USSound=Sound'MSolidSnakeSound.stealth_off'
				breathagain=Sound'MSolidSnakeSound.breathe2'
				Footstep1=Sound'MSolidSnakeSound.footstep_dirt'
				Footstep2=Sound'MSolidSnakeSound.footstep_dirt'
				Footstep3=Sound'MSolidSnakeSound.footstep_dirt'
				HitSound3=Sound'MSolidSnakeSound.bodyhit3'
				HitSound4=Sound'MSolidSnakeSound.bodyhit3'
				Die2=Sound'MSolidSnakeSound.role1_die2'
				Die3=Sound'MSolidSnakeSound.Die3'
				Die4=Sound'MSolidSnakeSound.Die3'
				GaspSound=Sound'MSolidSnakeSound.breathe2'
				JumpSound=Sound'MSolidSnakeSound.jump_concrete'
				HitSound1=Sound'MSolidSnakeSound.bodyhit3'
				HitSound2=Sound'MSolidSnakeSound.bodyhit3'
				Die=Sound'MSolidSnakeSound.Die1'
				LODBias=10.000000
				Texture=None
				Skin=None
				Mesh=LodMesh'AMM.solidsnake'
				MultiSkins(0)=Texture'Msolidsnakeskins.Skins.SnakeMoke'
				MultiSkins(1)=Texture'Msolidsnakeskins.Skins.SnakeMoke2'
				MultiSkins(2)=Texture'Msolidsnakeskins.Skins.SnakeMoke3'
}
